(function(angular, $, _) {
  "use strict";

  angular.module('crmKanban').component('searchAdminDisplayKanban', {
    bindings: {
      display: '<',
      apiEntity: '<',
      apiParams: '<'
    },
    require: {
      parent: '^crmSearchAdminDisplay'
    },
    templateUrl: '~/crmKanban/searchAdminDisplayKanban.html',
    controller: function($scope, searchMeta, crmUiHelp) {
      var ts = $scope.ts = CRM.ts('org.civicrm.search_kit'),
        ctrl = this;
      $scope.hs = crmUiHelp({file: 'CRM/Search/Help/Display'});

      // this is just an example
      this.kanbanClasses = [
        {
          name: 'crm-kanban_striped',
          label: 'Striped',
        }
      ];

      this.toggleClass = (className) => {
        if (!this.display.settings.classes) {
          this.display.settings.classes = [];
        }
        if (this.display.settings.classes.includes(className)) {
          this.display.settings.classes = this.display.settings.classes.filter((i) => i !== className)
        } else {
          this.display.settings.classes.push(className);
        }
      };

      this.getColTypes = function() {
        return ctrl.parent.colTypes;
      };

      this.$onInit = function () {
        if (!ctrl.display.settings) {
          ctrl.display.settings = {
            limit: 0,
            sort: ctrl.parent.getDefaultSort(),
            classes: [],
          };
        }
        ctrl.parent.initColumns({});
      };

    }
  });

})(angular, CRM.$, CRM._);
